<template>
    <div class='order-list_wrapper'>
        <div class="order-list_title">
            <h3>Список заказов</h3>
        </div>
        <div class='order-list'>
            <table class="table table-striped">
                <thead>
                    <tr>
                        <td>#</td>
                        <td>Ф.И.О заказчика</td>
                        <td>Позиции в заказе</td>
                        <td>Срок выполнения</td>
                        <td>Примечание</td>
                        <td>Итоговая цена</td>
                    </tr>
                </thead>
                <tbody>
                    <tr v-for="order in orders" :key="order.id">
                        <td>{{ order.id }}</td>
                        <td><a href="#">{{ order.clientName }}</a></td>
                        <td><span class="badge badge-secondary" v-for="selectedService in fundServicesByOrder(order.orderPositions)" :key="selectedService.id">{{selectedService.serviceName}} × {{selectedService.count}}</span></td>
                        <td>{{ order.finishdate }}</td>
                        <td>{{ order.comment }}</td>
                        <td>{{ calcOrderPrice(order.orderPositions) }} руб.</td>
                    </tr>
                </tbody>
            </table>
        </div>
        <div class='order-list_control'>
            <button class='btn btn-primary' v-on:click="callNewOrderForm">Добавление заказа</button>
        </div>

        <div class="modal" role="dialog" v-if="newOrder">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close" v-on:click="canselAddOrder">
                    <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <form>
                        <div class='form-group row'>
                            <label class="col-md-3">Ф.И.О заказчика</label>
                            <div class="col-md-9">
                                <input class="form-control" type="text" v-model="newOrder.clientName" required/>
                            </div>
                        </div>
                        <div class='form-group row'>
                            <label class="col-md-3">Перечень услуг</label>
                            <div class='add-order-services_list col-md-9'>
                                <div class='add-order-services_item row' v-for="(orderService, index) in servicesInOrderForm" :key="orderService.id">
                                    <div class="col-md-8">
                                        <select class="form-control" v-model="orderService.id" required>
                                            <option v-for="service in services" :key="service.id" v-bind:value="service.id">{{service.serviceName}}</option>
                                        </select>
                                    </div>
                                    <div class="col-md-3">
                                        <input class="form-control" type="number" v-model="orderService.count" v-on:change="addNewServiceInForm(orderService, index)" />
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class='form-group row'>
                            <label class="col-md-3">Срок выполнения</label>
                            <div class="col-md-9">
                                <input class="form-control" type="date" v-model="newOrder.finishdate" required />
                            </div>
                        </div>
                        <div class='form-group row'>
                            <label class="col-md-3">Примечание</label>
                            <div class="col-md-9">
                                <textarea class="form-control" type="" v-model="newOrder.comment" required></textarea>
                            </div>
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button class="btn btn-primary" v-on:click="addOrderInList">Сохранить</button>
                </div>
                </div>
            </div>
        </div>
    </div>
</template>
<script>
import Order from '../models/Order.js';

export default {
  name: 'Orders',
  data: function() {
      return {
          orders: [
              {
                id: 1,
                clientName: 'Иванов Иван Иванович',
                orderPositions: [{id: 1, count: 2},{id: 2, count: 1},{id: 3, count: 100}],
                comment: 'fffffffffffffffffffffff',
                finishdate: new Date(),
              }
          ],
          services: [
              {
                  id: 1,
                  serviceName: 'Услуга 1',
                  price: 5,
              },
              {
                  id: 2,
                  serviceName: 'Услуга 2',
                  price: 2
              },
              {
                  id: 3,
                  serviceName: 'Услуга 3',
                  price: 100
              },
          ],
          newOrder: null,
          servicesInOrderForm: []
      }
  },
  methods: {
    calcOrderPrice: function(service) {
        let totalPrice = 0;
        service.forEach(x => {
            let serviceData = this.services.find(e => e.id == x.id);
            totalPrice += serviceData.price * x.count; 
        })
        return totalPrice;
    },
    callNewOrderForm: function() {
        this.newOrder = new Order({});
    },
    addOrderInList: function() {
        if(!this.validateNewOrder(this.newOrder,['clientName','orderPositions','finishdate'])) {
            alert('Форма не заполнена');
            return;
        }

        this.newOrder.orderPositions = this.servicesInOrderForm.filter(x => x.count > 0).slice();
        this.newOrder.finishdate = new Date(this.newOrder.finishdate);
        this.orders.push(Object.assign({}, this.newOrder));
        this.clearServicesInOrderForm();
        this.newOrder = null;

    },
    clearServicesInOrderForm: function() {
        this.servicesInOrderForm.length = 0;
        this.servicesInOrderForm.push({
            id: this.services[0].id,
            count: 0
        });
    },
    addNewServiceInForm: function(orderService, index) {
        if(orderService.count > 0 && this.servicesInOrderForm.length - 1 == index) {
            this.servicesInOrderForm.push({
                id: this.services[0].id,
                count: 0
            });
        }
    },
    fundServicesByOrder: function(orderServicesIDs) {
        let orderServicesData = [];
        orderServicesIDs.forEach(x => {
            orderServicesData.push(Object.assign({ count: x.count }, this.services.find(e => e.id == x.id)));
        });
        return orderServicesData;
    },
    validateNewOrder(newOrder, requiredParams) {
        let validateStatus = true;
        requiredParams.forEach( x => { if(!newOrder[x]) validateStatus = false });
        return validateStatus;
    },
    canselAddOrder: function() {
        this.newOrder = null;
    }
  },
  mounted: function() {
    this.clearServicesInOrderForm();
  }
}
</script>
